#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "imapunorderediterator4xi.py">
#<abstract4xi abstract = "provides class IMapUnorderedIterator4Xi"/>
#<refer4xi reference = "pool.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'IMapUnorderedIterator4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import queue                    
    import itertools
    import collections
    import time          
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import IMapUnorderedIterator
except:
    print("imapunorderediterator4xi.py *** failed in from multiprocessing.pool import IMapUnorderedIterator ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from imapiterator4xi import IMapIterator4Xi

import constant_family4xi
import constant_heap4xi
import constant_pool4xi
import constant_synchronize4xi
import constant_system4xi

from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
  
#"
#/>



# =================================================================================================
#<class4xi class = "IMapUnorderedIterator4Xi" base = "IMapIterator4Xi" child = "None" synopsis = "IMapIterator4Xi" usage = "
#     pool.py
#         instances are returned by Pool.imap_unordered()                             
#         imap_unordered function uses as follows:
#             if chunksize == 1:
#                result = IMapUnorderedIterator(self._cache)
# pool4xi.py:
#     result2xi = IMapUnorderedIterator4Xi(self._cache)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class IMapUnorderedIterator4Xi(IMapIterator4Xi):
    '''
    IMapUnorderedIterator4Xi class IMapIterator4Xi     
    '''
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-IMapUnorderedIterator4Xi" usage = "sets with self, i, obj in pool module"> 
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def _set(self, i, obj):
        '''
        IMapUnorderedIterator4Xi method _set: sets with self, i, obj in pool module
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/4)
        # -----------------------------------------------------------------------------------------    
        class2print = "IMapUnorderedIterator4Xi"
        method2print = "_set"

        message2print = "{(Step 1/4a) started" + "; set-of-IMapUnorderedIterator4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                         
        message2print = "{(Step 1/4b) passed" + "; i-passed-to-set-of-IMapUnorderedIterator4Xi: " + str(i) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{(Step 1/4c) passed" + "; object-passed-to-set-of-IMapUnorderedIterator4Xi: " + str(obj) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/4)
        # -----------------------------------------------------------------------------------------          
        self._cond.acquire()
        message2print = "{(Step 2/4) performed" + "; cond-acquire-performed-by-set-of-IMapUnorderedIterator4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/4)
        # -----------------------------------------------------------------------------------------                           
        try:
            self._items.append(obj)
            
            message2print = "{(Step 3/4a) appended" + "; object-appended-by-set-of-IMapUnorderedIterator4Xi: " + str(obj) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            self._index += 1
            
            self._cond.notify()
            message2print = "{(Step 3/4b) performed" + "; cond-notify-performed-by-set-of-IMapUnorderedIterator4Xi: " + str(self._cond.notify) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                            
            if self._index == self._length:
                message2print = "{(Step 3/4c) passing" + "; job-passing-to-del-cache-by-set-of-IMapUnorderedIterator4Xi: " + str(self._job) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
           
                message2print = "{(Step 3/4d) deleting" + "; cache-job-deleting-by-set-of-IMapUnorderedIterator4Xi: " + str(self._cache[self._job]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 

                del self._cache[self._job]
        finally:
            self._cond.release()
            
            message2print = "{(Step 3/4e) performed" + "; cond-release-performed-by-set-of-IMapUnorderedIterator4Xi: " + str(self._cond.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                        
        # -----------------------------------------------------------------------------------------
        # (Step 4/4)
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 4/4) returning" + "; set-of-IMapUnorderedIterator4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
    #</methodize4xi>
            
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-IMapUnorderedIterator4Xi" usage = "senses class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses class objects
        '''
        
        
        class2print = 'IMapUnorderedIterator4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-IMapUnorderedIterator4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; IMapUnorderedIterator4Xi-sensing-by-sense-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-IMapUnorderedIterator4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; IMapUnorderedIterator4Xi-sensed-by-sense-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-IMapUnorderedIterator4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                        
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-IMapUnorderedIterator4Xi" usage = "reasons class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons class objects
        '''
        
        
        class2print = 'IMapUnorderedIterator4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-IMapUnorderedIterator4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; IMapUnorderedIterator4Xi-reasoning-by-reason-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-IMapUnorderedIterator4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; IMapUnorderedIterator4Xi-reasoned-by-reason-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-IMapUnorderedIterator4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-IMapUnorderedIterator4Xi" usage = "aces class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces class objects 
        '''
                 
        
        
        class2print = 'IMapUnorderedIterator4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-IMapUnorderedIterator4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; IMapUnorderedIterator4Xi-acing-by-ace-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-IMapUnorderedIterator4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; IMapUnorderedIterator4Xi-aced-by-ace-of-IMapUnorderedIterator4Xi: " + str(IMapUnorderedIterator4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-IMapUnorderedIterator4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of imapunorderediterator4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

 